首页   注册   登录
V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
Node.js
Express
PPA for Ubuntu
ppa:chris-lea/node.js
ubuntugx
V2EX  ›  Node.js

node 模块小问题

  •  2
     
  •   ubuntugx · 27 天前 · 2308 次点击
    node 识别 es module 的时候,怎么做到兼容的
    比如 fs 这个模块,是 module.exports 这样导出的
    那么 require('fs') 和 import 'fs' 都可以生效是怎么兼容的

    找了一些官方博客和文档里没有找到相关内容,准备去 debug 源码了,请问有人了解这块么~
    5 条回复    2020-03-29 16:56:25 +08:00
    libook
        1
    libook   27 天前
    不同的模式用不同的解释过程,这个你想了解细节还真得去看 Node 源码。

    不过 Node 是要求必须有地方能明确指出你当前文件到底是 ESM 还是 CommonJS,要么是通过文件扩展名,要么通过当前模块目录下的 package.json,目前看来 Node 是无法在同一文件内同时兼容两种模块语法的。
    unsad
        2
    unsad   27 天前
    执行入口文件时有判断。shouldUseESMLoader,在源码里搜一下这个方法。
    JayLin1011
        3
    JayLin1011   27 天前
    Node.js 本身不兼容 ES Module,仅支持 CommonJS 规范,但是有 babel 生态,比如 babel-register 等可以帮你把完成编译工作,所以你甚至可以在 Node 环境中使用 ES Module,当然,最新的 Demo 已经实现了模块化的大一统,面向未来 ES Module 仍是标准。
    ubuntugx
        4
    ubuntugx   26 天前
    node 在去年 11 月份的更新了对 esm 的支持 https://medium.com/@nodejs/announcing-core-node-js-support-for-ecmascript-modules-c5d6dc29b663

    这里问了 esm 和 cjs 的兼容问题,可以在源码里搜索到:
    node 源码 lib/internal/modules/cjs/loader.js 搜一下 default
    还有 esm/translators.js
    之后仔细研究后补充博客
    ubuntugx
        5
    ubuntugx   10 天前
    写了一篇博客讲 node 模块载入的事情 https://www.cnblogs.com/ubuntugx/p/12592584.html
    关于   ·   FAQ   ·   API   ·   我们的愿景   ·   广告投放   ·   感谢   ·   实用小工具   ·   1048 人在线   最高记录 5168   ·     Select Language
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.5 · 18ms · UTC 20:52 · PVG 04:52 · LAX 13:52 · JFK 16:52
    ♥ Do have faith in what you're doing.